## ukui-panel 4.0.0.4

=== CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(ukui-panel)

option(WITH_SCREENSAVER_FALLBACK "Include support for converting the deprecated 'screensaver' plugin to 'quicklaunch'. This requires the ukui-leave (ukui-session) to be installed in runtime." OFF)

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

macro(setByDefault VAR_NAME VAR_VALUE)
  if(NOT DEFINED ${VAR_NAME})
    set (${VAR_NAME} ${VAR_VALUE})
  endif(NOT DEFINED ${VAR_NAME})
endmacro()

include(GNUInstallDirs)

setByDefault(CUSTOM_QT_5_6_VERSION Yes)
setByDefault(CUSTOM_QT_5_12_VERSION No)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(KF5_MINIMUM_VERSION "5.18.0")
set(QT_MINIMUM_VERSION "5.6.1")
set(QTXDG_MINIMUM_VERSION "3.3.1")

find_package(KF5WindowSystem ${KF5_MINIMUM_VERSION} REQUIRED)
find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Core Quick QuickWidgets DBus X11Extras LinguistTools Xml)
find_package(Qt5Xdg ${QTXDG_MINIMUM_VERSION} REQUIRED)
find_package(X11 REQUIRED)

find_package(PkgConfig)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${Gsetting_INCLUDE_DIRS})
set(LIBRARIES
    ${Gsetting_LIBRARIES}
    -lukui-log4qt
)

# Patch Version
set(UKUI_VERSION 3.0)
set(UKUI_PANEL_PATCH_VERSION 0)
set(UKUI_MAJOR_VERSION 3)
set(UKUI_MINOR_VERSION 0)

#set(UKUI_TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/translations/")
set(UKUI_PANEL_VERSION ${UKUI_MAJOR_VERSION}.${UKUI_MINOR_VERSION}.${UKUI_PANEL_PATCH_VERSION})
add_definitions("-DUKUI_PANEL_VERSION=\"${UKUI_PANEL_VERSION}\"")

include(./cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
#include(./cmake/ukui-build-tools/modules/UKUiTranslate.cmake)

# All UKUiCompilerSettings except CMAKE_MODULE_LINKER_FLAGS work just fine
# So we reset only these Flags after loading UKUiCompilerSettings
# ukui-build-tools:
#  set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--no-undefined ${SYMBOLIC_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "==OLD== CMAKE_MODULE_LINKER_FLAGS: ${CMAKE_MODULE_LINKER_FLAGS}")
set( OLD_CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${OLD_CMAKE_MODULE_LINKER_FLAGS} ${SYMBOLIC_FLAGS}")

# Warning: This must be before add_subdirectory(panel). Move with caution.
set(PLUGIN_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ukui-panel")
add_definitions(
    -DPLUGIN_DIR=\"${PLUGIN_DIR}\"
)
#Add PACKAGE_DATA_DIR
set(PACKAGE_DATA_DIR "/usr/share/ukui-panel")
add_definitions(
    -DPACKAGE_DATA_DIR=\"${PACKAGE_DATA_DIR}\"
    -DQT_MESSAGELOGCONTEXT
)

message(STATUS "CMAKE Module linker flags: ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "Panel plugins location: ${PLUGIN_DIR}")

#########################################################################
# Plugin system
# You can enable/disable building of the plugin using cmake options.
#    cmake -DWORLDCLOCK_PLUGIN=Yes .. # Enable worldclock plugin
#    cmake -DWORLDCLOCK_PLUGIN=No ..  # Disable worldclock plugin

include("cmake/BuildPlugin.cmake")
include(./cmake/ukui-build-tools/modules/UKUiTranslateDesktop.cmake)
include(./cmake/ukui-build-tools/modules/UKUiTranslationLoader.cmake)
set(ENABLED_PLUGINS) # list of enabled plugins
set(STATIC_PLUGINS) # list of statically linked plugins

setByDefault(QUICKLAUNCH_PLUGIN No)
if(QUICKLAUNCH_PLUGIN)
    list(APPEND STATIC_PLUGINS "quicklaunch")
    add_definitions(-DWITH_QUICKLAUNCH_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Quicklaunch")
    add_subdirectory(plugin-quicklaunch)
endif()


setByDefault(SHOWDESKTOP_PLUGIN Yes)
if(SHOWDESKTOP_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Show Desktop")
    add_subdirectory(plugin-showdesktop)
endif()


setByDefault(TASKBAR_PLUGIN Yes)
if(TASKBAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "taskbar")
    add_subdirectory(plugin-taskbar)
endif()

add_subdirectory(panel-daemon)
add_subdirectory(sni-daemon)
add_subdirectory(sni-xembed-proxy)
add_subdirectory(plugin-ukcc)

setByDefault(STATUSNOTIFIER_PLUGIN Yes)
if(STATUSNOTIFIER_PLUGIN)
    list(APPEND ENABLED_PLUGINS "statusnotifier")
    add_subdirectory(plugin-statusnotifier)
endif()

setByDefault(SPACER_PLUGIN Yes)
if(SPACER_PLUGIN)
    list(APPEND STATIC_PLUGINS "spacer")
    add_definitions(-DWITH_SPACER_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Spacer")
    add_subdirectory(plugin-spacer)
endif()

setByDefault(CALENDAR_PLUGIN Yes)
if(CALENDAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "calendar")
    add_subdirectory(plugin-calendar)
endif(CALENDAR_PLUGIN)

setByDefault(STARTBAR_PLUGIN Yes)
if(STARTBAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "startbar")
    add_subdirectory(plugin-startbar)
endif(STARTBAR_PLUGIN)

#########################################################################

message(STATUS  "**************** The following plugins will be built ****************")
foreach (PLUGIN_STR ${ENABLED_PLUGINS})
    message(STATUS "  ${PLUGIN_STR}")
endforeach()
message(STATUS "*********************************************************************")

add_subdirectory(panel)

file(GLOB_RECURSE QRC_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.qrc)

## translation
#set(UKUI_TRANSLATIONS_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ukui/)
#add_definitions(
#    -DUKUI_TRANSLATIONS_DIR="${UKUI_TRANSLATIONS_DIR}"
#)
#if (NOT DEFINED UPDATE_TRANSLATIONS)
#    set(UPDATE_TRANSLATIONS "No")
#endif()

## To create a new ts file: lupdate -recursive . -target-language zh_CN -ts panel/resources/ukui-panel_zh_CN.ts
#file(GLOB TS_FILES "${CMAKE_CURRENT_SOURCE_DIR}/panel/resources/*.ts")

## cmake -DUPDATE_TRANSLATIONS=yes
#if (UPDATE_TRANSLATIONS)
#    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
#else()
#    qt5_add_translation(QM_FILES ${TS_FILES})
#endif()
#add_custom_target(translations ALL DEPENDS ${QM_FILES})
#install(FILES ${QM_FILES} DESTINATION ${UKUI_TRANSLATIONS_DIR})

=== panel-daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(panel-daemon)

#判断编译器类型,如果是gcc编译器,则在编译选项中加入c++11支持
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
    message(STATUS "optional:-std=c++11")
endif(CMAKE_COMPILER_IS_GNUCXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(Qt5 COMPONENTS Widgets Network REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF5WindowSystem REQUIRED)

pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)
pkg_check_modules(QGS REQUIRED gsettings-qt)

include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${QGS_INCLUDE_DIRS})

add_executable(panel-daemon
    jsonwathcer/jsonwacther.cpp
    jsonwathcer/jsonwacther.h
    filewatcher/filewatcher.cpp
    filewatcher/filewatcher.h
    convert-desktop-windowid/convertdesktoptowinid.cpp
    convert-desktop-windowid/convertdesktoptowinid.h
    pin-totaskbar/pintotaskbar.cpp
    pin-totaskbar/pintotaskbar.h
    pin-totaskbar/taskbar-dbus-adaptor.cpp
    pin-totaskbar/taskbar-dbus-adaptor.h
    dbus-server/server.cpp
    dbus-server/server.h
    dbus-server/dbus-adaptor.cpp
    dbus-server/dbus-adaptor.h
    datewather/datewatcher.cpp
    datewather/datewatcher.h
    watchermanager.cpp
    watchermanager.h
    main.cpp
)


add_definitions(-DQT_MESSAGELOGCONTEXT)

pkg_check_modules(KYSDKWAYLANDHELPER_PKG kysdk-waylandhelper)
target_include_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_LIBRARY_DIRS} KF5::WindowSystem)
target_link_libraries(${PROJECT_NAME} ${KYSDKWAYLANDHELPER_PKG_LIBRARIES})

target_link_libraries(${PROJECT_NAME}
    Qt5::Widgets
    Qt5::DBus
    Qt5::Network
    ${GLIB2_LIBRARIES}
    ${QGS_LIBRARIES}
    KF5::WindowSystem
    )


install(TARGETS panel-daemon DESTINATION bin)

install(FILES
    resources/ukui-panel-daemon.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

=== panel/CMakeLists.txt ===
project(ukui-panel LANGUAGES C CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_subdirectory(common)

set(PRIV_HEADERS
    panelpluginsmodel.h
    ukuipanel.h
    ukuipanelapplication.h
    ukuipanelapplication_p.h
    ukuipanellayout.h
    plugin.h
    pluginsettings_p.h
    contextmenu.h
)

# using UKUi namespace in the public headers.
set(PUB_HEADERS
    ukuipanelglobals.h
    pluginsettings.h
    iukuipanelplugin.h
    iukuipanel.h
    common/ukuisettings.h
    common/ukuiplugininfo.h
    common/ukuitranslator.h
    common/common.h
    common/ukuigridlayout.h
    common/ukuiglobals.h
    common_fun/listengsettings.h
    common_fun/ukuipanel_infomation.h
    common_fun/dbus-adaptor.h
    common_fun/panel_commission.h
    customstyle.h
)

set(SOURCES
    main.cpp
    panelpluginsmodel.cpp
    windownotifier.cpp
    ukuipanel.cpp
    ukuipanelapplication.cpp
    ukuipanellayout.cpp
    plugin.cpp
    pluginsettings.cpp
    contextmenu.cpp
    common/ukuiplugininfo.cpp
    common/ukuisettings.cpp
    common/ukuitranslator.cpp
    common/ukuigridlayout.cpp
    common_fun/listengsettings.cpp
    common_fun/ukuipanel_infomation.cpp
    common_fun/dbus-adaptor.cpp
    common_fun/panel_commission.cpp
    customstyle.cpp
)

set(PLUGIN_DESKTOPS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/${PROJECT_NAME}")
set(QTX_LIBRARIES Qt5::Widgets Qt5::Xml Qt5::DBus)
set(UKUI_PANEL_MAN ../man/ukui-panel.1)
set(DESKTOP_FILE resources/ukui-panel.desktop)
set(IMAGE_DIR ./img/)
set(GSETTINGS_FILE resources/org.ukui.panel.settings.gschema.xml)
set(PANEL_GLOBAL_CONFIG_FILES resources/panel-commission.ini)
set(PANEL_GLOBAL_CONFIG_EXEC_FILES resources/panel-commission.sh
                            resources/ukui-panel-reset.sh resources/ukui-panel-config.sh)
file(GLOB UKUI_PANEL_CONFIG_FILES resources/*.conf)

add_definitions(-DCOMPILE_UKUI_PANEL)
add_definitions(-DPLUGIN_DESKTOPS_DIR=\"${PLUGIN_DESKTOPS_DIR}\")

if (WITH_SCREENSAVER_FALLBACK)
    message(STATUS "Building with conversion of deprecated 'screensaver' plugin")
    add_definitions(-DWITH_SCREENSAVER_FALLBACK "-DUKUI_LOCK_DESKTOP=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}/applications/ukui-lockscreen.desktop\"")
endif ()


set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")

# 翻译文件
file(GLOB TS_FILES "translation/*.ts")
# 更新翻译并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR} ${TS_FILES})
add_executable(${PROJECT_NAME}
    ${PUB_HEADERS}
    ${PRIV_HEADERS}
    ${QM_FILES}
    ${SOURCES}
)

find_package(PkgConfig)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${Gsetting_INCLUDE_DIRS})

find_package(PkgConfig REQUIRED)
find_package(KF5WindowSystem)
find_package(KF5Screen)
pkg_check_modules(KYSDKWAYLANDHELPER_PKG kysdk-waylandhelper)

#ADD_DEFINITIONS(-DQT_NO_KEYWORDS)
target_link_libraries(${PROJECT_NAME}
    ${LIBRARIES}
    ${QTX_LIBRARIES}
    KF5::WindowSystem
    ${STATIC_PLUGINS}
    Qt5Xdg
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${Gsetting_LIBRARIES}
    Qt${QT_VERSION_MAJOR}::Quick
    KF5::Screen
)

target_include_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_LIBRARY_DIRS} KF5::WindowSystem)
target_link_libraries(${PROJECT_NAME} ${KYSDKWAYLANDHELPER_PKG_LIBRARIES})

target_compile_definitions(${PROJECT_NAME}
    PRIVATE
        "UKUI_RELATIVE_SHARE_DIR=\"${UKUI_RELATIVE_SHARE_DIR}\""
        "UKUI_RELATIVE_SHARE_TRANSLATIONS_DIR=\"${UKUI_RELATIVE_TRANSLATIONS_DIR}\""
        "UKUI_SHARE_TRANSLATIONS_DIR=\"${UKUI_TRANSLATIONS_DIR}\""
        "UKUI_GRAPHICS_DIR=\"${UKUI_GRAPHICS_DIR}\""
        "UKUI_DATA_DIR=\"${UKUI_DATA_DIR}\""   
        "UKUI_INSTALL_PREFIX=\"${CMAKE_INSTALL_PREFIX}\""
)

#安装ukui-panel
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)
#DESKTOP FILE
install(FILES ${DESKTOP_FILE} DESTINATION "/etc/xdg/autostart/" COMPONENT Runtime)
install(FILES ${UKUI_PANEL_CONFIG_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/ukui)
install(FILES ${PUB_HEADERS} DESTINATION include/ukui)
install(FILES ${UKUI_PANEL_MAN} DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT Runtime)
install(FILES ${GSETTINGS_FILE} DESTINATION "/usr/share/glib-2.0/schemas" COMPONENT Runtime)
install(FILES ${PANEL_GLOBAL_CONFIG_FILES} DESTINATION "/usr/share/ukui/ukui-panel" COMPONENT Runtime
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ GROUP_WRITE WORLD_READ WORLD_WRITE)
install(FILES ${PANEL_GLOBAL_CONFIG_EXEC_FILES} DESTINATION "/usr/share/ukui/ukui-panel" COMPONENT Runtime
    PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ GROUP_WRITE WORLD_READ WORLD_WRITE WORLD_EXECUTE)
install(DIRECTORY ${IMAGE_DIR} DESTINATION "${PACKAGE_DATA_DIR}/panel/img")

set(PLUGIN panel)
set(PANEL_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/panel/translation")
add_compile_definitions(PANEL_TRANSLATION_DIR="${PANEL_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION "${PANEL_TRANSLATION_DIR}")

=== plugin-taskbar/CMakeLists.txt ===
set(PLUGIN "taskbar")

set(HEADERS
    ukuitaskbutton.h
    ukuitaskgroup.h
    windowThumbnailModel.h
    windowThumbnailManager.h
    ukuitaskbar.h
    ukuitaskbarplugin.h
    iconTheme.h
    windowThumbnailView.h
    kbadge.h
    )

set(SOURCES
    ukuitaskbutton.cpp
    ukuitaskgroup.cpp
    windowThumbnailModel.cpp
    windowThumbnailManager.cpp
    ukuitaskbar.cpp
    ukuitaskbarplugin.cpp
    iconTheme.cpp
    qml.qrc
    windowThumbnailView.cpp
    kbadge.cpp
)

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core Widgets X11Extras LinguistTools DBus Quick Qml REQUIRED)
find_package(KF5Wayland)
find_package(KF5WindowSystem)
find_package(KF5IconThemes)
find_package(Qt5WaylandClient)
find_package(PlasmaWaylandProtocols 1.6 REQUIRED)
find_package(Qt5Xdg REQUIRED)

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
include(FindQtWaylandScanner)
add_subdirectory(window-thumbnail)
add_subdirectory(ukui-panel-items)

find_package(PkgConfig REQUIRED)
set(UKUI_TASK_MANAGER_PC_PKGS kysdk-waylandhelper)
foreach(external_lib IN ITEMS ${UKUI_TASK_MANAGER_PC_PKGS})
    pkg_check_modules(${external_lib} REQUIRED IMPORTED_TARGET ${external_lib})
    if(${${external_lib}_FOUND})
        include_directories(${${external_lib}_INCLUDE_DIRS})
        link_directories(${${external_lib}_LIBRARY_DIRS})
        list(APPEND UKUI_TASK_MANAGER_EXTERNAL_LIBS PkgConfig::${external_lib})
    endif()
endforeach()

pkg_check_modules(KDKINFO kysdk-sysinfo)
if (KDKINFO_FOUND)
    ADD_DEFINITIONS(-DKDKINFO_FOUND="true")
    include_directories(${KDKINFO_INCLUDE_DIRS})
    link_directories(${KDKINFO_LIBRARY_DIRS})
    list(APPEND EXTERNAL_LIBS ${KDKINFO_LIBRARIES})
endif()

pkg_check_modules(GIO-UNIX REQUIRED gio-unix-2.0)
if (GIO-UNIX_FOUND)
	include_directories(${GIO-UNIX_INCLUDE_DIRS})
	link_directories(${GIO-UNIX_LIBRARY_DIRS})
endif()

#qt5_add_resources(qrc_FILES qmlItems.qrc)

set(LIBRARIES
    Qt5Xdg
    Qt5X11Extras
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::X11Extras
    Qt${QT_VERSION_MAJOR}::Qml
    ${UKUI_TASK_MANAGER_EXTERNAL_LIBS}
    KF5::WindowSystem
)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/plugin-taskbar/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR}/plugin-taskbar ${TS_FILES})
set(${PLUGIN}_QM_FILES ${QM_FILES})

BUILD_UKUI_PLUGIN(${PLUGIN})
#安装翻译文件
set(TASKBAR_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-taskbar/translation")
add_compile_definitions(TASKBAR_TRANSLATION_DIR="${TASKBAR_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION ${TASKBAR_TRANSLATION_DIR})


#set(SignalForwarding_SRC
#        signalforwarding.cpp
#        waylandhelper.cpp
#        main.cpp
#        windowmanager/abstractinterface.cpp
#        windowmanager/waylandinterface.cpp
#        windowmanager/windowmanager.cpp
#        windowmanager/wmregister.cpp
#        windowmanager/xcbinterface.cpp
#)
#
#set(WINDOW_THUMBNAIL_PLUGIN_PC_PKGS wayland-client)
#foreach(external_lib IN ITEMS ${WINDOW_THUMBNAIL_PLUGIN_PC_PKGS})
#    pkg_check_modules(${external_lib} REQUIRED IMPORTED_TARGET ${external_lib})
#    if(${${external_lib}_FOUND})
#        include_directories(${${external_lib}_INCLUDE_DIRS})
#        link_directories(${${external_lib}_LIBRARY_DIRS})
#        list(APPEND WINDOW_THUMBNAIL_PLUGIN_EXTERNAL_LIBS PkgConfig::${external_lib})
#    endif()
#endforeach()
#
#ecm_add_qtwayland_client_protocol(SignalForwarding_SRC
#        PROTOCOL ${PLASMA_WAYLAND_PROTOCOLS_DIR}/plasma-window-management.xml
#        BASENAME plasma-window-management
#)
#
#add_executable(signalforwarding ${SignalForwarding_SRC})
#
#target_link_libraries(signalforwarding PRIVATE
#        Qt5::Core
#        Qt5::Widgets
#        Qt5::DBus
#        KF5::WaylandClient
#        KF5::WindowSystem
#        KF5::IconThemes
#        Qt5::X11Extras
#        ${WINDOW_THUMBNAIL_PLUGIN_EXTERNAL_LIBS})
#
#add_subdirectory(sample)

=== sni-xembed-proxy/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(sni-xembed-proxy)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(Qt5 COMPONENTS Widgets Network REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(Qt5X11Extras REQUIRED)
find_package(X11 REQUIRED)

add_executable(sni-xembed-proxy
        main.cpp
        snixembedproxy.cpp
        sniproxy.cpp
        snidbus.cpp
        statusnotifierwatcher_interface.cpp
        xtestsender.cpp

        snixembedproxy.h
        sniproxy.h
        snidbus.h
        statusnotifierwatcher_interface.h
        systemtraytypedefs.h
        xcbutilss.h
        xtestsender.h
)

target_link_libraries(sni-xembed-proxy
    Qt5::X11Extras
    Qt5::Widgets
    Qt5::DBus
    KF5::WindowSystem
    xcb
    xcb-util
    xcb-damage
    xcb-image
    xcb-composite
    xcb-shape
    -lukui-log4qt
    -lQt5Xdg
    ${XCB_LIBS}
    ${X11_XTest_LIB}
    )

add_definitions(-DQT_NO_KEYWORDS)
add_definitions(-DQT_MESSAGELOGCONTEXT)

install(TARGETS sni-xembed-proxy DESTINATION bin)

install(FILES
    resources/sni-xembed-proxy.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

=== panel/common/CMakeLists.txt ===

set(UKUIBT_MINIMUM_VERSION "0.6.0")
set(KF5_MINIMUM_VERSION "5.36.0")
set(QT_MINIMUM_VERSION "5.7.1")
set(QTXDG_MINIMUM_VERSION "3.3.1")

# Major UKUi Version, belong to all components
set(UKUI_MAJOR_VERSION 0)
# Minor UKUi Version, belong to all components
set(UKUI_MINOR_VERSION 14)
#
# Patch Version, belong *only* to the component
# UKUi is 0.13 - libukui is at patch version 0
# The official UKUi version will follow libukui.
#
# In a perfect world all components would have the same major- and minor- and
# patch-version as libukui - in real life it will be fine if every component
# has it's own patch version within a major/minor life cyle.
#
set(UKUI_PATCH_VERSION 1)
set(UKUI_VERSION ${UKUI_MAJOR_VERSION}.${UKUI_MINOR_VERSION}.${UKUI_PATCH_VERSION})


option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)


#find_package(ukui-build-tools ${UKUIBT_MINIMUM_VERSION} REQUIRED)
#find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets DBus X11Extras LinguistTools)
#find_package(Qt5Xdg ${QTXDG_MINIMUM_VERSION} REQUIRED)
#find_package(KF5WindowSystem ${KF5_MINIMUM_VERSION} REQUIRED)
#find_package(PolkitQt5-1 REQUIRED)
#find_package(X11 REQUIRED)
message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt5Core_VERSION}")

include(CMakePackageConfigHelpers)
include(GNUInstallDirs) # Standard directories for installation


set(UKUI_PKG_CONFIG_DESCRIPTION "Shared library for UKUi applications")

set(HEADERS
    ukuisettings.h
    ukuiplugininfo.h
    ukuitranslator.h

    ukuigridlayout.h
    ukuiglobals.h
)

set(PUBLIC_CLASSES
    Settings
    PluginInfo
    Application
    SingleApplication
    Translator

    PageSelectWidget

    GridLayout
    Globals
)

set(SOURCES
    ukuiplugininfo.cpp
    ukuisettings.cpp
    ukuitranslator.cpp
    ukuiprogramfinder.cpp

    ukuigridlayout.cpp
)

set(MOCS
    ukuisettings.h
    ukuiscreensaver.h
    ukuiapplication.h

    ukuigridlayout.h
)

set(FORMS
    configdialog/ukuiconfigdialog.ui
)

file(GLOB UKUI_CONFIG_FILES resources/*.conf)

set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")

# KF5WindowSystem is missing here. KF5WindowSystem doesn't provide an .pc file.
set(UKUI_PKG_CONFIG_REQUIRES "Qt5Xdg >= ${QTXDG_MINIMUM_VERSION}, Qt5Widgets >= ${QT_MINIMUM_VERSION}, Qt5Xml >= ${QT_MINIMUM_VERSION}, Qt5DBus >= ${QT_MINIMUM_VERSION}, Qt5X11Extras >= ${QT_MINIMUM_VERSION}")


# Standard directories for installation
include(../../cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCompilerSettings.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePkgConfigFile.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiCreatePortableHeaders.cmake)
include(../../cmake/ukui-build-tools/modules/UKUiConfigVars.cmake)

set(UKUI_INTREE_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/include")

set(UKUI_INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${UKUI_LIBRARY_NAME}")
set(UKUI_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/cmake")


## Translations

#include(../cmake/ukui-build-tools/modules/UKUiTranslateTs.cmake)

#ukui_translate_ts(QM_FILES
#   UPDATE_TRANSLATIONS
#       ${UPDATE_TRANSLATIONS}
#   SOURCES
#       ${SRCS}
#        ${FORMS}
#    INSTALL_DIR
#        "${UKUI_TRANSLATIONS_DIR}/${PROJECT_NAME}"
#)

message(STATUS "")
message(STATUS "libukui version: ${UKUI_VERSION}")
message(STATUS "")


# Copy public headers
foreach(h ${HEADERS})
    get_filename_component(bh ${h} NAME)
    configure_file(${h} "${UKUI_INTREE_INCLUDE_DIR}/UKUi/${bh}" COPYONLY)
endforeach()

# Create the portable headers
ukui_create_portable_headers(INTREE_PORTABLE_HEADERS
    NAME_PREFIX "ukui"
    OUTPUT_DIR "${UKUI_INTREE_INCLUDE_DIR}/UKUi"
    HEADER_NAMES ${PUBLIC_CLASSES}
)

#check_portable_headers(H_FILES ${PUB_HDRS} LINKS "${INTREE_PORTABLE_HEADERS}")

#************************************************
# Create in-tree build infrastructure
#************************************************
set(CFG_UKUI_TARGETS_FILE   "${UKUI_INTREE_TARGETS_FILE}")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ukui-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${UKUI_LIBRARY_NAME}-config.cmake"
    INSTALL_DESTINATION "neverland"     # required, altough we don't install it
)

#************************************************
# Create installable build infrastructure
#************************************************
set(CFG_UKUI_TARGETS_FILE "${UKUI_INSTALL_CMAKE_DIR}/${UKUI_LIBRARY_NAME}/${UKUI_LIBRARY_NAME}-targets.cmake")

#install(EXPORT
#    ${UKUI_LIBRARY_NAME}-targets
#    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${UKUI_LIBRARY_NAME}"
#    COMPONENT Devel
#)


if (Qt5Core_VERSION VERSION_LESS "5.9.0")
    if (NOT DEFINED WITH_XDG_DIRS_FALLBACK)
        set(WITH_XDG_DIRS_FALLBACK ON)
    endif ()
elseif (WITH_XDG_DIRS_FALLBACK)
    set(WITH_XDG_DIRS_FALLBACK OFF)
    message(WARNING "Disabling requested WITH_XDG_DIRS_FALLBACK workaround, as proper implementation is in Qt from v5.9.0")
endif ()
if (WITH_XDG_DIRS_FALLBACK)
    message(STATUS "Building with homemade QSettings XDG fallback workaround")

setByDefault(CUSTOM_QT_5_12_VERSION Yes)
if (CUSTOM_QT_5_12_VERSION )
	#target_compile_definitions(${UKUI_LIBRARY_NAME}
	#PRIVATE "WITH_XDG_DIRS_FALLBACK"
	#)
endif(CUSTOM_QT_5_12_VERSION)
endif ()

#install(FILES
   # ${PUB_HDRS}
  #  DESTINATION "${UKUI_INSTALL_INCLUDE_DIR}/UKUi"
 #   COMPONENT Devel
#)

#install(FILES
   # ${INTREE_PORTABLE_HEADERS}
  #  DESTINATION "${UKUI_INSTALL_INCLUDE_DIR}/UKUi"
 #   COMPONENT Devel
#)

#install(FILES ${UKUI_CONFIG_FILES}
  #  DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/ukui"
 #   COMPONENT Runtime
#)

#install(FILES ${POLKIT_FILES} DESTINATION "${POLKITQT-1_POLICY_FILES_INSTALL_DIR}")

#************************************************
# Create and install pkgconfig file
#************************************************
ukui_create_pkgconfig_file(
    PACKAGE_NAME ${UKUI_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${UKUI_LIBRARY_NAME}
    DESCRIPTION ${UKUI_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${UKUI_LIBRARY_NAME}
    REQUIRES ${UKUI_PKG_CONFIG_REQUIRES}
    VERSION ${UKUI_VERSION}
    INSTALL
)
#************************************************

=== plugin-taskbar/window-thumbnail/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ukui-window-thumbnail)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#find QT modules
find_package(QT NAMES Qt6 Qt5 COMPONENTS Core Gui Qml X11Extras Quick DBus REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Qml Gui X11Extras Quick DBus REQUIRED)

#find kde modules
find_package(KF5Wayland)
find_package(KF5WindowSystem)
find_package(Qt5WaylandClient)
find_package(PlasmaWaylandProtocols 1.6 REQUIRED)

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
find_package(XCB MODULE COMPONENTS XCB COMPOSITE DAMAGE SHAPE XFIXES RENDER)
message("XCB:"${X11_FOUND}, ${XCB_XCB_FOUND}, ${XCB_COMPOSITE_FOUND}, ${XCB_DAMAGE_FOUND})
if(X11_FOUND AND XCB_XCB_FOUND)
    set(HAVE_X11 1)
endif()
if(HAVE_X11 AND XCB_COMPOSITE_FOUND AND XCB_DAMAGE_FOUND)
    set(HAVE_XCB_COMPOSITE 1)
endif()

find_package(OpenGL)
find_package(EGL MODULE)
message("EGL:"${EGL_FOUND})
if (${EGL_FOUND})
    set(HAVE_EGL 1)
endif()
message("OPENGL:"${OPENGL_FOUND},${Qt5Gui_OPENGL_IMPLEMENTATION})
if(OPENGL_FOUND AND (${Qt5Gui_OPENGL_IMPLEMENTATION} STREQUAL "GL"))
    set(HAVE_GLX ${HAVE_X11})
else()
    set(HAVE_GLX 0)
endif()
message("MACRO:"${HAVE_X11},${HAVE_XCB_COMPOSITE},${HAVE_EGL},${HAVE_GLX})
add_compile_definitions(HAVE_X11=${HAVE_X11})
add_compile_definitions(HAVE_EGL=${HAVE_EGL})
add_compile_definitions(HAVE_GLX=${HAVE_GLX})


set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
include(FindQtWaylandScanner)

#find other modules
find_package(PkgConfig REQUIRED)
set(WINDOW_THUMBNAIL_PLUGIN_PC_PKGS libpipewire-0.3 x11 xcb xcb-damage xcb-composite egl xcb-render wayland-client kysdk-waylandhelper)
foreach(external_lib IN ITEMS ${WINDOW_THUMBNAIL_PLUGIN_PC_PKGS})
    pkg_check_modules(${external_lib} REQUIRED IMPORTED_TARGET ${external_lib})
    if(${${external_lib}_FOUND})
        include_directories(${${external_lib}_INCLUDE_DIRS})
        link_directories(${${external_lib}_LIBRARY_DIRS})
        list(APPEND WINDOW_THUMBNAIL_PLUGIN_EXTERNAL_LIBS PkgConfig::${external_lib})
    endif()
endforeach()

include_directories(mpris)
set (PLUGIN_SRCS
        screen-casting-request.cpp
        screen-casting.cpp
        pipewire-core.cpp
        pipewire-source-stream.cpp
        pipewire-source-item.cpp
        window-thumbnail-plugin.cpp
        x-window-thumbnail.cpp
        window-thumbnail-config.cpp
        window-thumbnail-config.h
        mpris/mpris-player-collecter.cpp
        mpris/mpris-player-collecter.h
        mpris/player-item.cpp
        mpris/player-item.h
        mpris/player-items-model.cpp
        mpris/player-items-model.h
        mpris/window-thumbnail-mpris-model.cpp
        mpris/window-thumbnail-mpris-model.h
        mpris/properties.h
)
#generate wayland protocol files
ecm_add_qtwayland_client_protocol(PLUGIN_SRCS
        PROTOCOL ${PLASMA_WAYLAND_PROTOCOLS_DIR}/screencast.xml
        BASENAME zkde-screencast-unstable-v1
)
set_source_files_properties(
        mpris/org.freedesktop.DBus.Properties.xml
        mpris/org.mpris.MediaPlayer2.Player.xml
        mpris/org.mpris.MediaPlayer2.xml
        PROPERTIES
        NO_NAMESPACE ON)
if(COMMAND qt_add_dbus_interface)
    qt_add_dbus_interface(PLUGIN_SRCS mpris/org.freedesktop.DBus.Properties.xml dbusproperties)
    qt_add_dbus_interface(PLUGIN_SRCS mpris/org.mpris.MediaPlayer2.xml mprisplayer2)
    qt_add_dbus_interface(PLUGIN_SRCS mpris/org.mpris.MediaPlayer2.Player.xml mprisplayer2player)
else()
    qt5_add_dbus_interface(PLUGIN_SRCS mpris/org.freedesktop.DBus.Properties.xml dbusproperties)
    qt5_add_dbus_interface(PLUGIN_SRCS mpris/org.mpris.MediaPlayer2.xml mprisplayer2)
    qt5_add_dbus_interface(PLUGIN_SRCS mpris/org.mpris.MediaPlayer2.Player.xml mprisplayer2player)
endif()

add_library(${PROJECT_NAME} SHARED ${PLUGIN_SRCS})


set(PLUGIN_IMPORT_URI "org.ukui.windowThumbnail")
target_compile_definitions(${PROJECT_NAME} PRIVATE PLUGIN_IMPORT_URI="${PLUGIN_IMPORT_URI}")

target_link_libraries(${PROJECT_NAME}
        PRIVATE
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Qml
        Qt${QT_VERSION_MAJOR}::Gui
        Qt${QT_VERSION_MAJOR}::Quick
        Qt${QT_VERSION_MAJOR}::Gui_EGL
        Qt${QT_VERSION_MAJOR}::GuiPrivate
        Qt${QT_VERSION_MAJOR}::X11Extras
        Qt${QT_VERSION_MAJOR}::DBus
        ${WINDOW_THUMBNAIL_PLUGIN_EXTERNAL_LIBS}
        KF5::WaylandClient
        KF5::WindowSystem
    )

set(PLUGIN_INSTALL_PATH "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml/org/ukui/windowThumbnail")
install(DIRECTORY "qml" DESTINATION "${PLUGIN_INSTALL_PATH}")
install(FILES qmldir DESTINATION ${PLUGIN_INSTALL_PATH})
install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH})

=== debian/changelog ===
ukui-panel (4.0.0.4-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:22:59 +0000

ukui-panel (4.0.0.4-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 19 Mar 2024 11:47:21 +0800

ukui-panel (4.0.0.3-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 09 Mar 2024 14:03:32 +0800

ukui-panel (4.0.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 25 Feb 2024 11:36:22 +0800

=== debian/control ===
Source: ukui-panel
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>,
           xibowen <xibowen@kylinos.cn>
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               libdbusmenu-qt5-dev,
               libdrm-dev,
               libglib2.0-dev(>=2.36),
               libgsettings-qt-dev,
               libkf5i18n-dev,
               libkf5screen-dev,
               libkf5wayland-dev,
               libkf5windowsystem-dev,
               libkysdk-applications-dev,
               libkysdk-base-dev,
               libpipewire-0.3-dev,
               libqt5waylandclient5-dev,
               libqt5x11extras5-dev,
               libqt5xdg-dev,
               libukcc-dev,
               libukui-log4qt-dev,
               libx11-dev,
               libxcb-composite0-dev,
               libxcb-damage0-dev,
               libxcb-image0-dev,
               libxcb-shape0-dev,
               libxcb-util-dev,
               libxtst-dev,
               plasma-wayland-protocols,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qtwayland5-dev-tools
Standards-Version: 4.6.1.0
Rules-Requires-Root: no
Homepage: https://gitee.com/openkylin/ukui-panel
Vcs-Git: https://gitee.com/openkylin/ukui-panel.git
Vcs-Browser: https://gitee.com/openkylin/ukui-panel

Package: ukui-panel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: ukui-indicators
Suggests: time-shutdown, ukui-window-switch (>=3.0.0-3)
Description: ukui desktop panel
 The ukui desktop panel is used on ukui desktop and has some plugins like
 starmenu, quicklaunch and other useful tools.
 .
 This package contains the ukui panel.

## ukui-panel 4.0.0.5

=== panel/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,6 @@
     iukuipanel.h
     common/ukuisettings.h
     common/ukuiplugininfo.h
-    common/ukuitranslator.h
     common/common.h
     common/ukuigridlayout.h
     common/ukuiglobals.h
@@ -33,6 +32,10 @@
     common_fun/dbus-adaptor.h
     common_fun/panel_commission.h
     customstyle.h
+    xdg-desktop-file/xdgdesktopfile_p.h
+    xdg-desktop-file/xdgdesktopfile.h
+    xdg-desktop-file/xdgdirs.h
+    xdg-desktop-file/xdgmacros.h
 )
 
 set(SOURCES
@@ -47,13 +50,15 @@
     contextmenu.cpp
     common/ukuiplugininfo.cpp
     common/ukuisettings.cpp
-    common/ukuitranslator.cpp
     common/ukuigridlayout.cpp
     common_fun/listengsettings.cpp
     common_fun/ukuipanel_infomation.cpp
     common_fun/dbus-adaptor.cpp
     common_fun/panel_commission.cpp
     customstyle.cpp
+    xdg-desktop-file/desktopenvironment_p.cpp
+    xdg-desktop-file/xdgdesktopfile.cpp
+    xdg-desktop-file/xdgdirs.cpp
 )
 
 set(PLUGIN_DESKTOPS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/${PROJECT_NAME}")
@@ -79,6 +84,11 @@
 set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
 list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")
 
+QT5_ADD_DBUS_INTERFACE(libqtxdg_DBUS_INTERFACE_SRCS
+    xdg-desktop-file/dbus/org.freedesktop.Application.xml
+    application_interface
+)
+
 # 翻译文件
 file(GLOB TS_FILES "translation/*.ts")
 # 更新翻译并创建.qm文件
@@ -88,6 +98,7 @@
     ${PRIV_HEADERS}
     ${QM_FILES}
     ${SOURCES}
+    ${libqtxdg_DBUS_INTERFACE_SRCS}
 )
 
 find_package(PkgConfig)
@@ -109,7 +120,6 @@
     ${QTX_LIBRARIES}
     KF5::WindowSystem
     ${STATIC_PLUGINS}
-    Qt5Xdg
     ${GLIB2_LIBRARIES}
     ${GIO2_LIBRARIES}
     ${Gsetting_LIBRARIES}

=== plugin-calendar/CMakeLists.txt ===
﻿set(PLUGIN "calendar")

set(HEADERS
    ukuicalendarplugin.h
    ukuicalendarwidget.h
    calendarbutton.h
    calendarbuttontext.h
    ukuiwebviewdialog.h
    lunarcalendarwidget/frmlunarcalendarwidget.h
    lunarcalendarwidget/lunarcalendarinfo.h
    lunarcalendarwidget/lunarcalendaritem.h
    lunarcalendarwidget/lunarcalendaryearitem.h
    lunarcalendarwidget/lunarcalendarmonthitem.h
    lunarcalendarwidget/lunarcalendarwidget.h
    lunarcalendarwidget/picturetowhite.h
    lunarcalendarwidget/customstylePushbutton.h
    lunarcalendarwidget/calendarcolor.h
)

set(SOURCES
    ukuicalendarplugin.cpp
    ukuicalendarwidget.cpp
    calendarbutton.cpp
    calendarbuttontext.cpp
    ukuiwebviewdialog.cpp
    lunarcalendarwidget/frmlunarcalendarwidget.cpp
    lunarcalendarwidget/lunarcalendarinfo.cpp
    lunarcalendarwidget/lunarcalendaritem.cpp
    lunarcalendarwidget/lunarcalendaryearitem.cpp
    lunarcalendarwidget/lunarcalendarmonthitem.cpp
    lunarcalendarwidget/lunarcalendarwidget.cpp
    lunarcalendarwidget/picturetowhite.cpp
    lunarcalendarwidget/customstylePushbutton.cpp
    lunarcalendarwidget/calendarcolor.cpp
)

set(UIS
    ukuiwebviewdialog.ui
    lunarcalendarwidget/frmlunarcalendarwidget.ui
)

find_package(PkgConfig)

pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${Gsetting_INCLUDE_DIRS})

pkg_check_modules(CALENDAR_DEPS REQUIRED glib-2.0)
link_libraries(glib-2.0.so)


pkg_check_modules(KDKSYSTIME kysdk-systime)
if (KDKSYSTIME_FOUND)
    ADD_DEFINITIONS(-DKDKSYSTIME_FOUND="true")

    include_directories(${KDKSYSTIME_PKG_INCLUDE_DIRS})
    link_directories(${KDKSYSTIME_PKG_LIBRARY_DIRS})
    link_libraries(kydate.so)
endif()

# pkg_check_modules(KYSDKSYSTIME_PKG kysdk-systime)
# include_directories(${KYSDKSYSTIME_PKG_INCLUDE_DIRS})
# link_directories(${KYSDKSYSTIME_PKG_LIBRARY_DIRS})
# link_libraries(kydate.so)

pkg_check_modules(KYSDKQTWIDGETS_PKG kysdk-qtwidgets)
include_directories(${KYSDKQTWIDGETS_PKG_INCLUDE_DIRS})
link_directories(${KYSDKQTWIDGETS_PKG_LIBRARY_DIRS})
link_libraries(kysdk-qtwidgets.so)

pkg_check_modules(KYSDKWAYLANDHELPER_PKG kysdk-waylandhelper)
include_directories(${KYSDKWAYLANDHELPER_PKG_INCLUDE_DIRS})
link_directories(${KYSDKWAYLANDHELPER_PKG_LIBRARY_DIRS})
link_libraries(kysdk-waylandhelper.so)


include_directories(${CALENDAR_DEPS_INCLUDE_DIRS})

ADD_DEFINITIONS(-DQT_NO_KEYWORDS)
install(DIRECTORY html/
        DESTINATION ${PACKAGE_DATA_DIR}/plugin-calendar/html)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/plugin-calendar/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR} ${TS_FILES})
set(${PLUGIN}_QM_FILES ${QM_FILES})

BUILD_UKUI_PLUGIN(${PLUGIN})

#安装翻译文件
set(CALENDAR_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-calendar/translation")
add_compile_definitions(CALENDAR_TRANSLATION_DIR="${CALENDAR_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION ${CALENDAR_TRANSLATION_DIR})

=== plugin-taskbar/CMakeLists.txt ===
--- 
+++ 
@@ -26,12 +26,12 @@
 )
 
 find_package(QT NAMES Qt6 Qt5 COMPONENTS Core Widgets X11Extras LinguistTools DBus Quick Qml REQUIRED)
+
 find_package(KF5Wayland)
 find_package(KF5WindowSystem)
 find_package(KF5IconThemes)
 find_package(Qt5WaylandClient)
 find_package(PlasmaWaylandProtocols 1.6 REQUIRED)
-find_package(Qt5Xdg REQUIRED)
 
 find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
@@ -67,7 +67,6 @@
 #qt5_add_resources(qrc_FILES qmlItems.qrc)
 
 set(LIBRARIES
-    Qt5Xdg
     Qt5X11Extras
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::DBus

=== panel/common/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,6 @@
 set(HEADERS
     ukuisettings.h
     ukuiplugininfo.h
-    ukuitranslator.h
 
     ukuigridlayout.h
     ukuiglobals.h
@@ -52,7 +51,6 @@
     PluginInfo
     Application
     SingleApplication
-    Translator
 
     PageSelectWidget
 
@@ -63,7 +61,6 @@
 set(SOURCES
     ukuiplugininfo.cpp
     ukuisettings.cpp
-    ukuitranslator.cpp
     ukuiprogramfinder.cpp
 
     ukuigridlayout.cpp

=== debian/changelog ===
ukui-panel (4.0.0.5-1) unstable; urgency=medium

  * New upstream release:
    - libqtxdg transition (Closes: #1089000)
  * d/control: remove libqt5xdg-dev.
    d/copyright: update for new files.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 23 Dec 2024 10:38:27 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ukui-panel
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: kylin Team <team+kylin@tracker.debian.org>
+Maintainer: kylin Team <team+kylin@tracker.debian.org>
 Uploaders: Aron Xu <aron@debian.org>,
            handsome_feng <jianfengli@ubuntukylin.com>,
            xibowen <xibowen@kylinos.cn>
@@ -22,7 +21,6 @@
                libpipewire-0.3-dev,
                libqt5waylandclient5-dev,
                libqt5x11extras5-dev,
-               libqt5xdg-dev,
                libukcc-dev,
                libukui-log4qt-dev,
                libx11-dev,
